﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Warship
{
    internal abstract class AbstractMap
    {
        private IDrawingObject _drawingObject = null;
        protected int[,] _map = null;
        protected int _width;
        protected int _height;
        protected float _size_x;
        protected float _size_y;
        protected readonly Random _random = new();
        protected readonly int _freeWaterArea = 0;
        protected readonly int _land = 1;

        public Bitmap CreateMap(int width,int height,IDrawingObject drawingObject)
        {
            _width = width;
            _height = height;
            _drawingObject = drawingObject;
            GenerateMap();
            while (!SetObjectOnMap())
            {
                GenerateMap();
            }
            return DrawMapWithObject();
        }

        public Bitmap MoveObject(Direction direction)
        {

            if (true)
            {
                _drawingObject.MoveObject(direction);
            }
            return DrawMapWithObject();
        }

        private bool SetObjectOnMap()
        {
            if (_drawingObject==null || _map == null)
            {
                return false;
            }
            int x = _random.Next(0, 10);
            int y = _random.Next(0, 10);
            _drawingObject.SetObject(x, y, _width, _height);
            int i=(_width - x) / (int)_size_x;
            int j = (_height - y) / (int)_size_y;
            for 
            return true;
        }

        private Bitmap DrawMapWithObject()
        {
            Bitmap bmp = new(_width, _height);
            if (_drawingObject == null || _map == null)
            {
                return bmp;
            }
            Graphics gr = Graphics.FromImage(bmp);
            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    if (_map[i,j] == _freeWaterArea)
                    {
                        DrawWaterPart(gr, i, j);
                    }
                    else if (_map[i, j] == _land)
                    {
                        DrawLandPart(gr, i, j);
                    }
                }
            }
            _drawingObject.DrawingObject(gr);
            return bmp;
        }



        protected abstract void GenerateMap();
        protected abstract void DrawWaterPart(Graphics gr, int i, int j);
        protected abstract void DrawLandPart(Graphics gr, int i, int j);
    }
}
